import type { ComponentCtor, ComponentDescriptor, AppHelper, ActionDescriptor, ModuleDescriptor } from '../vendors/organik';
import type { ThemeOptions } from './theme';
declare type MountEl = Element | string;
declare type AppHelperCreator = () => Omit<AppHelper, 'session'>;
interface AppCreators {
    appHelper?: AppHelperCreator;
}
interface AppDescriptor {
    components?: ComponentDescriptor[];
    metadata?: {
        actions?: ActionDescriptor[];
        modules?: ModuleDescriptor[];
    };
    creators?: AppCreators;
    theme?: ThemeOptions;
    root?: ComponentCtor;
    el?: MountEl;
}
interface AppInstance {
    mount(el?: MountEl): void;
}
export type { AppCreators, AppDescriptor, AppInstance };
