import dayjs from 'dayjs';
import { divided } from '../vendors/toolbox';
function createMoment(date, format, strictOrLocale, strict) {
    return dayjs(date, format, strictOrLocale, strict);
}
function resolveDateValue(date, format) {
    if (!date) {
        return '';
    }
    // JS timestamp
    if (format === 'timestamp') {
        return date.getTime();
    }
    // Unix timestamp
    if (format === 'unix') {
        return divided(date.getTime(), 1000);
    }
    return createMoment(date).format(format);
}
export { createMoment, resolveDateValue };
