import { isDate, isString, isNumber, includes } from '../vendors/toolbox';
import { BuiltInDataType } from '../types/data-type';
import { createMoment } from './date';
function isEnumField(field) {
    return includes(field.dataType, [BuiltInDataType.Enum, BuiltInDataType.MultiEnum]);
}
function isUnixTimestamp(value) {
    return isNumber(value) && /^[0-9]{10}(\.[0-9]{3})?$/.test(`${value}`);
}
function isDateValue(value) {
    if (isDate(value)) {
        return true;
    }
    return isString(value) || isNumber(value)
        ? createMoment((isUnixTimestamp(value) ? value * 1000 : value)).isValid()
        : false;
}
export { isEnumField, isUnixTimestamp, isDateValue };
