import type { ButtonProps } from 'petals-ui/dist/button';
import { ConfigType, ComponentCtor, ClientAction, ModuleContext, ViewContext } from '../../vendors/organik';
import type { ActionRendererProps } from '../../types/renderer';
import type { ActionWidgetConfig } from '../../types/widget';
declare function resolveActionWidgetCtor<WidgetCtor extends ComponentCtor = ComponentCtor>(moduleContext: ModuleContext, { action }: ActionRendererProps): WidgetCtor | undefined;
declare function executeClientAction<CT extends ActionWidgetConfig = ActionWidgetConfig>(viewContext: ViewContext, action: ClientAction<CT>, config?: CT): void;
declare function resolveButtonProps<CT extends ConfigType>({ primary, danger }: ClientAction<CT>, config: CT, disabled: boolean): Partial<ButtonProps>;
declare function resolveIconProps({ icon }: ConfigType): Record<string, any>;
declare function resolveLinkProps(config: ConfigType): Record<string, any>;
declare function resolveControlPropsAndEvents(props: Record<string, any>, options: Record<string, any>): {
    props: Record<string, any>;
    events: Record<string, any>;
};
export { resolveActionWidgetCtor, executeClientAction, resolveButtonProps, resolveIconProps, resolveLinkProps, resolveControlPropsAndEvents, };
