import { isString, omit } from '../../vendors/toolbox';
import { isWidgetDependency, getWidget, } from '../../vendors/organik';
function createBindEventResolver(eventNameGetter) {
    return (viewLibInst, event) => {
        let resolved;
        if (isString(event)) {
            resolved = eventNameGetter(viewLibInst, event);
        }
        else {
            resolved = {};
            Object.keys(event).forEach(key => {
                resolved[eventNameGetter(viewLibInst, key)] = event[key];
            });
        }
        return resolved;
    };
}
function resolveWidgetCtor(moduleContext, widget, widgetNameFromRenderTypeResolver) {
    if (widget) {
        if (isString(widget)) {
            return isWidgetDependency(moduleContext.getModuleName(), widget)
                ? moduleContext.getComponents()[widget]
                : undefined;
        }
        return widget;
    }
    return getWidget(widgetNameFromRenderTypeResolver());
}
const commonUnsafeKeys = ['className', 'style', 'nativeStyle', 'tag', 'title'];
function resolveSafePropsFromConfig(config, specificUnsafeKeys) {
    return omit(config, [...commonUnsafeKeys, ...specificUnsafeKeys]);
}
export { createBindEventResolver, resolveWidgetCtor, resolveSafePropsFromConfig };
