import type { IBaseComponent } from '@petals/basic';
import { FlexBreakpointListProp } from 'petals-ui/dist/basic';
import type { IFormComponent } from 'petals-ui/dist/form';
import type { IDialogComponent } from 'petals-ui/dist/dialog';
import { HistoryHelper, ConfigType, ComponentCtor, InputDescriptor, ClientAction, ViewContext, ListViewContext, createModuleContext } from '../../vendors/organik';
import type { ActionRenderType } from '../../types/render-type';
import type { ViewFieldDescriptor } from '../../types/input';
import type { DataTableProps } from '../../types/view';
import type { FormRendererProps, ViewRendererProps } from '../../types/renderer';
import type { DialogViewWidgetConfig } from '../../types/widget';
declare function renderFormChildren<DescriptorType extends InputDescriptor & {
    hidden?: boolean;
}, NodeType>(descriptors: DescriptorType[], arrangement: string | undefined, renderGroup: (title: string, formFieldNodes: NodeType[]) => NodeType, renderChild: (descriptor: DescriptorType) => NodeType, renderRow: (descriptors: DescriptorType[], cols: FlexBreakpointListProp[] | number) => NodeType): NodeType[];
declare function renderForm<NodeType>(props: FormRendererProps, renderGroup: (title: string, formFieldNodes: NodeType[]) => NodeType, renderChild: (descriptor: ViewFieldDescriptor) => NodeType, renderRow: (descriptors: ViewFieldDescriptor[], cols: FlexBreakpointListProp[] | number) => NodeType, render: (stuff: {
    FormControl?: ComponentCtor;
    props: Partial<IFormComponent & IBaseComponent>;
    children: NodeType[];
}) => NodeType): NodeType;
declare function resolveViewWidgetCtor<WidgetCtor extends ComponentCtor = ComponentCtor>(props: ViewRendererProps, componentAsserter: (ctor: any) => boolean, moduleContextCreator?: typeof createModuleContext): WidgetCtor | undefined;
declare function isConditionPersisted(viewContext: ListViewContext): boolean;
declare function persistsInUrl(history: HistoryHelper, params: Record<string, any>): void;
declare function restoreFromUrl(history: HistoryHelper): Record<string, any>;
declare function isActionsAuthorized(actionsAuthority: string | undefined): boolean;
declare function resolveActionsAuthority(viewContext: ViewContext): string | undefined;
declare function resolveAuthorizedActions(actions: ClientAction[], actionsAuthority: string | undefined): ClientAction[];
declare const resolveItemActions: (viewContext: ViewContext<any, Record<string, any>>) => ClientAction<Record<string, any>>[];
declare function resolveActionStuffs<A extends ClientAction<ConfigType> = ClientAction<ConfigType>>(viewContext: ViewContext): {
    top: A[];
    item: A[];
    map: Record<string, A>;
};
declare function resolveTableProps(context: ListViewContext, inlineButtonSize: string, inlineActionRenderType: ActionRenderType, cellRendererResolver: any, operationColumnResolver: any): DataTableProps;
declare function resolveSafeDialogProps<CT extends DialogViewWidgetConfig = DialogViewWidgetConfig>(config: CT): Partial<IDialogComponent>;
export { renderFormChildren, renderForm, resolveViewWidgetCtor, isConditionPersisted, persistsInUrl, restoreFromUrl, isActionsAuthorized, resolveActionsAuthority, resolveAuthorizedActions, resolveItemActions, resolveActionStuffs, resolveTableProps, resolveSafeDialogProps, };
