import EventEmitter from '@ntks/event-emitter';
import { DataValue, ValueContextDescriptor, ValueEvents, ValueContext as IValueContext } from '../core';
declare class ValueContext<ValueType extends DataValue = DataValue, EventNames extends string = ValueEvents> extends EventEmitter<EventNames> implements IValueContext<ValueType, EventNames> {
    private readonly defaultValue;
    private value;
    private valueInited;
    constructor({ defaultValue, initialValue }: ValueContextDescriptor<ValueType>);
    getDefaultValue(): ValueType;
    getValue(): ValueType;
    setValue(value: ValueType): void;
    isReady(): boolean;
    submit(): void;
    reset(): void;
}
export { ValueContext };
