import { DataValue, RequestParams, ResponseResult, ResponseSuccess, ResponseFail, ConfigType, ValueChecker, ModuleContext, ObjectViewContextDescriptor, ObjectViewContext as IObjectViewContext } from '../../core';
import { ViewContext } from './base';
declare class ObjectViewContext<ValueType extends DataValue = DataValue, Config extends ConfigType = ConfigType> extends ViewContext<ValueType, Config> implements IObjectViewContext<ValueType, Config> {
    private readonly parent;
    private readonly indexInParent;
    private readonly validationTiming;
    private readonly shorthandNames;
    private readonly validatorMap;
    private invalidFieldMap;
    private modified;
    private validateFieldValue;
    constructor(moduleContext: ModuleContext, options: ObjectViewContextDescriptor<ValueType, Config>);
    getParent(): any;
    getIndexInParent(): number;
    setDataSource(data: ValueType): void;
    setValue(value: ValueType): void;
    getFieldValue<FV extends DataValue = DataValue>(name: string): FV | undefined;
    setFieldValue<FV>(name: string, value: FV): void;
    setFieldChecker(name: string, checker: ValueChecker): void;
    isModified(): boolean;
    submit(): void;
    reset(): void;
    getOne(params: string | number | Record<string, any>, success?: ResponseSuccess, fail?: ResponseFail): Promise<ResponseResult>;
    insert(params: RequestParams, success?: ResponseSuccess, fail?: ResponseFail): Promise<ResponseResult>;
    update(params: RequestParams, success?: ResponseSuccess, fail?: ResponseFail): Promise<ResponseResult>;
}
export { ObjectViewContext };
