import { isString } from '@ntks/toolbox';
const actionMap = new Map();
function registerAction(name, action) {
    let resolvedName;
    let resolvedDescriptor;
    if (isString(name)) {
        resolvedDescriptor = action;
        resolvedName = name;
    }
    else {
        resolvedDescriptor = name;
        resolvedName = resolvedDescriptor.name;
    }
    actionMap.set(resolvedName, resolvedDescriptor);
}
function getAction(name) {
    return actionMap.get(name);
}
function resolveAction(refOrDescriptor) {
    if (isString(refOrDescriptor)) {
        return getAction(refOrDescriptor);
    }
    const descriptor = refOrDescriptor;
    if (!descriptor.name) {
        return descriptor;
    }
    const registered = getAction(descriptor.name);
    return registered ? Object.assign(Object.assign({}, registered), descriptor) : descriptor;
}
export { registerAction, resolveAction };
