import type { DataValue } from './value';
import type { Result } from './feedback';
declare type RequestParams = DataValue;
declare type Pagination = {
    pageNum: number;
    pageSize: number;
};
declare type ResponseExtra = Pagination & {
    total: number;
    [key: string]: any;
};
interface ResponseResult<VT extends DataValue = DataValue> extends Required<Result> {
    code: string;
    data: VT;
    extra: ResponseExtra;
}
declare type ResponseSuccess<T = any> = (data: T, extra: ResponseExtra, result: ResponseResult<T>) => any;
declare type ResponseFail<T = any> = (message: string, result: ResponseResult<T>) => any;
export type { RequestParams, Pagination, ResponseExtra, ResponseResult, ResponseSuccess, ResponseFail, };
