import type { ComponentCtor } from '../component';
import type { LocationRoute } from '../app';
import type { ConfigType, InputDescriptor } from './base';
interface FilterDescriptor extends InputDescriptor {
    hidden?: boolean;
}
declare type SearchInitialValueGetter<VT extends Record<string, any> = Record<string, any>> = <ViewContext>(route: LocationRoute, viewContext: ViewContext) => VT;
interface SearchDescriptor<CT extends ConfigType = ConfigType, VT extends Record<string, any> = Record<string, any>> {
    filters: (FilterDescriptor | string)[];
    config?: CT;
    initialValue?: VT | SearchInitialValueGetter<VT>;
}
declare type SearchComponentRenderer = SearchDescriptor | ComponentCtor;
export type { FilterDescriptor, SearchInitialValueGetter, SearchDescriptor, SearchComponentRenderer, };
