import { ViewContext } from '../../vendors/organik';
import { ActionWidgetConfig, IActionWidget } from '../../types/widget/action';
import { BaseHeadlessWidget } from '../base';
declare class ActionHeadlessWidget<CT extends ActionWidgetConfig = ActionWidgetConfig> extends BaseHeadlessWidget<IActionWidget<CT>, CT> {
    private getAction;
    getConfig(): CT;
    resolveClassNames(className?: string): string;
    /**
     * Execute client action with view context
     *
     * @param viewContext injected view context
     */
    execute(viewContext: ViewContext): void;
    /**
     * Render content of action widget
     *
     * @param iconWithTextRenderer render `Icon` component and text
     * @returns content of action widget
     */
    renderContent<NodeType>(iconWithTextRenderer: (iconRef: string, text: string, iconOnly: boolean) => NodeType[]): NodeType[] | string;
}
export { ActionHeadlessWidget };
