import { DataValue, ConfigType, AppHelper, ViewContext } from '../../vendors/organik';
declare type WidgetBehaviors = {
    [key: string]: any;
};
declare abstract class BaseHeadlessWidget<WidgetProps, CT extends ConfigType = ConfigType> {
    private readonly __widgetProps;
    private readonly __viewContext;
    private readonly __appHelper;
    private __behaviorKey;
    private __behaviors;
    protected getProps(): WidgetProps;
    protected getProp<K extends keyof WidgetProps>(key: K): WidgetProps[K];
    protected getViewContext<V extends ViewContext = ViewContext>(): V;
    constructor(props: WidgetProps, viewContext: ViewContext);
    abstract getConfig(): CT;
    getAppHelper(): AppHelper;
    setBehaviors(keyInTheme: string, options: WidgetBehaviors): void;
    getBehavior(path: string): DataValue;
    getCommonBehavior(path: string, defaultBehavior?: DataValue): DataValue;
}
export { BaseHeadlessWidget };
