import { getAppHelper } from '../../vendors/organik';
import { retrieveData, getBehaviorByKey } from '../../utils';
class BaseHeadlessWidget {
    constructor(props, viewContext) {
        this.__widgetProps = props;
        this.__viewContext = viewContext;
        this.__appHelper = getAppHelper();
    }
    getProps() {
        return this.__widgetProps;
    }
    getProp(key) {
        return this.getProps()[key];
    }
    getViewContext() {
        return this.__viewContext;
    }
    getAppHelper() {
        return this.__appHelper;
    }
    setBehaviors(keyInTheme, options) {
        this.__behaviorKey = keyInTheme;
        this.__behaviors = options;
    }
    getBehavior(path) {
        return getBehaviorByKey(`${this.__behaviorKey}.${path}`, retrieveData(this.__behaviors, path));
    }
    getCommonBehavior(path, defaultBehavior) {
        return getBehaviorByKey(`common.${path}`, defaultBehavior);
    }
}
export { BaseHeadlessWidget };
