import type { DateValue } from '../../types/value';
import type { DateFieldWidgetConfig } from '../../types/widget/field';
import { FieldHeadlessWidget } from './Field';
declare class DateFieldHeadlessWidget<VT extends DateValue | DateValue[], CT extends DateFieldWidgetConfig = DateFieldWidgetConfig> extends FieldHeadlessWidget<VT, CT> {
    private __defaultFormat;
    setDefaultFormat(format: string): void;
    getDisplayFormat(): string;
    private getValueFormat;
    private formatDate;
    resolveDateValue(date: Date | null): DateValue;
    /**
     * Get display date value
     *
     * @returns date value for display
     */
    getDateValue(): DateValue;
    /**
     * Get display date range
     *
     * @returns date range for display
     */
    getRangeValue(): DateValue[];
    setRangeValue(dates: (Date | null)[] | null, onChange: (value: VT) => void): void;
    getRangePlaceholders(): string[];
    getSeparator(): string;
}
export { DateFieldHeadlessWidget };
