import type { DataValue } from '../../vendors/organik';
import type { UnknownViewField, ViewFieldDescriptor } from '../../types/input';
import type { FieldWidgetConfig, IFieldWidget } from '../../types/widget/field';
import { BaseHeadlessWidget } from '../base';
declare class FieldHeadlessWidget<VT extends DataValue = DataValue, CT extends FieldWidgetConfig = FieldWidgetConfig, FT extends UnknownViewField = ViewFieldDescriptor> extends BaseHeadlessWidget<IFieldWidget<VT>, CT> {
    protected getField(): FT;
    protected getFieldValue(): VT | undefined;
    getConfig(): CT;
    getPlaceholder(): string;
    isValidationRulesShownAsNative(configFromView: boolean | undefined): boolean;
    format(value?: VT): string;
}
export { FieldHeadlessWidget };
