import { isBoolean, isFunction } from '../../utils';
import { resolvePlaceholder } from '../../utils/widget';
import { BaseHeadlessWidget } from '../base';
class FieldHeadlessWidget extends BaseHeadlessWidget {
    getField() {
        return this.getProp('field');
    }
    getFieldValue() {
        return this.getViewContext().getFieldValue(this.getField().name);
    }
    getConfig() {
        return (this.getField().config || {});
    }
    getPlaceholder() {
        return resolvePlaceholder(this.getField(), this.getConfig().showHintAsPlaceholder, this.getCommonBehavior('field.showHintAsPlaceholder'));
    }
    isValidationRulesShownAsNative(configFromView) {
        return isBoolean(configFromView)
            ? configFromView
            : this.getCommonBehavior('field.showValidationRulesAsNative', false);
    }
    format(value = this.getProp('value')) {
        return isFunction(this.getField().formatter)
            ? this.getField().formatter(value, this.getViewContext().getValue())
            : value;
    }
}
export { FieldHeadlessWidget };
