import { DateValue } from '../../types/value';
import { DateFilterWidgetConfig } from '../../types/widget/filter';
import { FilterHeadlessWidget } from './Filter';
declare class DateFilterHeadlessWidget<VT extends DateValue | DateValue[], CT extends DateFilterWidgetConfig = DateFilterWidgetConfig> extends FilterHeadlessWidget<VT, CT> {
    private __defaultFormat;
    setDefaultFormat(format: string): void;
    getDisplayFormat(): string;
    private getValueFormat;
    private formatDate;
    resolveDateValue(date: Date | null): DateValue;
    /**
     * Get display date range
     *
     * @returns date range for display
     */
    getRangeValue(): DateValue[];
    setRangeValue(dates: (Date | null)[] | null, onChange: (value: VT) => void): void;
    getRangePlaceholders(): string[];
    getSeparator(): string;
}
export { DateFilterHeadlessWidget };
