import type { DataValue, SearchContext } from '../../vendors/organik';
import type { UnknownFilter, FilterDescriptor } from '../../types/input';
import type { FilterWidgetConfig, IFilterWidget } from '../../types/widget/filter';
import { BaseHeadlessWidget } from '../base';
declare class FilterHeadlessWidget<VT extends DataValue = DataValue, CT extends FilterWidgetConfig = FilterWidgetConfig, FT extends UnknownFilter = FilterDescriptor> extends BaseHeadlessWidget<IFilterWidget<VT>, CT> {
    protected getFilter(): FT;
    protected getFilterValue(): VT | undefined;
    protected getSearchContext(): SearchContext;
    getConfig(): CT;
    getPlaceholder(): string;
    isValidationRulesShownAsNative(): boolean;
    isImmediate(): boolean;
}
export { FilterHeadlessWidget };
