import { BaseHeadlessWidget } from '../base';
class AdminLayoutHeadlessWidget extends BaseHeadlessWidget {
    getConfig() {
        return {};
    }
    /**
     * Get menu status flags
     *
     * @returns active and open menu route names
     */
    getMenuFlags() {
        const { name, ancestors } = this.getAppHelper().history.getLocation();
        return { active: name, open: ancestors.length > 0 ? ancestors.map(a => a.name) : [name] };
    }
}
export { AdminLayoutHeadlessWidget };
