import { isFunction, isConditionPersisted, persistsInUrl, restoreFromUrl } from '../../utils';
import { BaseHeadlessWidget } from '../base';
class SearchHeadlessWidget extends BaseHeadlessWidget {
    getConfig() {
        return (this.getViewContext().getSearch().config ||
            {});
    }
    resolveInitialSettings() {
        const viewContext = this.getViewContext();
        const searchContext = viewContext.getSearchContext();
        const settings = { condition: searchContext.getDefaultValue() };
        // FIXME: 临时做法
        const searchInitialValue = viewContext.getSearch().initialValue;
        const { history } = this.getAppHelper();
        if (searchInitialValue) {
            settings.condition = Object.assign(Object.assign({}, settings.condition), (isFunction(searchInitialValue)
                ? searchInitialValue(history.getLocation(), viewContext)
                : searchInitialValue));
        }
        if (isConditionPersisted(viewContext)) {
            settings.condition = Object.assign(Object.assign({}, settings.condition), restoreFromUrl(history));
            const persists = () => persistsInUrl(history, Object.assign(Object.assign({}, searchContext.getValue()), { pageNum: viewContext.getCurrentPage() }));
            settings.events = { submit: persists, reset: persists };
        }
        return settings;
    }
}
export { SearchHeadlessWidget };
